import shlex
import socket
import subprocess
import threading
import time
import sys
import os
import logging.handlers


LOG_DIR = "/opt/apps/kylincloud-remoteappclient/log"
if not os.path.exists(LOG_DIR):
    os.makedirs(LOG_DIR)
LOG_PATH = "%s/record_server.log" % LOG_DIR
if not os.path.exists(LOG_PATH):
    f = open(LOG_PATH, 'w+')
    f.close()
record_log = logging.handlers.RotatingFileHandler(LOG_PATH, maxBytes=1024 * 1024,
                                                  backupCount=5, encoding="utf-8")
fmt = '%(asctime)s - %(funcName)s[line:%(lineno)d] - %(levelname)s - %(message)s'
for_matter = logging.Formatter(fmt)
record_log.setFormatter(for_matter)
logger = logging.getLogger(LOG_PATH)
logger.addHandler(record_log)
logger.setLevel(logging.DEBUG)

with open("/opt/apps/kylincloud-remoteappclient/cfg/admin_config.conf", "r") as f:
    cont = f.read()
    model_info = cont.strip().split('\n')
model = model_info[1]
print(model, type(model))


def socket_service():
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        s.bind(('127.0.0.1', 6666))
        s.listen(10)
    except socket.error as msg:
        logger.error(msg)
        sys.exit(1)
    print('Waiting connection...')
 
    while 1:
        conn, addr = s.accept()
        t = threading.Thread(target=deal_data, args=(conn, addr))
        t.start()


def deal_data(conn, addr):
    while 1:
        data = conn.recv(1024)
        test = format(data.decode())
        try:
            action = test.split(' ')[0]
            usbid = test.split(' ')[1]
            logger.info('action:%s usbid:%s' % (action,usbid))
            if str(action) == "bind":
                if model == "model = reverse":
                    try:
                        os.system("/opt/apps/usbip/sbin/usbip bind -b %s" % usbid)
                    except Exception as e:
                        print(e)
                elif model == "model = positive":
                    server_ip = test.split(' ')[2]
                    usb_devicedid = test.split(' ')[3]
                    shell_cmd = "/opt/apps/usbip/sbin/usbipc -s %s bind -b %s" % (server_ip, usbid)
                    cmd = shlex.split(shell_cmd)
                    p = subprocess.Popen(cmd, shell=False, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
                    line = p.stdout.readlines(1000)
                    if line:
                        log = ""
                        for i in line:
                            info = bytes.decode(i)
                            if info != "\n":
                                log += info
                    log += "----------------"
                    if "rc: 0" not in log:
                        if "already bound to usbip-host" in log:
                            logger.error("already bind")
                            logger.error(log)
                            try:
                                conn.send(b'1,'+ usb_devicedid.encode())
                            except Exception as e:
                                print(e)
                        elif "specified bus ID does not exist" in log:
                            logger.error("id is not exist")
                            logger.error(log)
                            try:
                                conn.send(b'2,'+ usb_devicedid.encode())
                            except Exception as e:
                                print(e)
                        else:
                            logger.error(log)
                            try:
                                conn.send(b'3,'+ usb_devicedid.encode())
                            except Exception as e:
                                print(e)
                    else:
                        logger.info(log)
                        try:
                            conn.send(b'4,'+ usb_devicedid.encode())
                        except Exception as e:
                            print(e)
            elif str(action) == "unbind":
                shell_cmd = "/opt/apps/usbip/sbin/usbip unbind -b %s" % usbid
                cmd = shlex.split(shell_cmd)
                p = subprocess.Popen(cmd, shell=False, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
                line = p.stdout.readlines(1000)
                if line:
                    log = ""
                    for i in line:
                        info = bytes.decode(i)
                        if info != "\n":
                            log += info
                with open(LOG_PATH, "a") as f:
                    f.write(log)
                print("-------")
            else :
                pass
        except Exception as e:
            pass
        time.sleep(1)


if __name__ == '__main__':
    socket_service()
