import socket
import subprocess
import threading
import time
import sys
import os
import logging.handlers


LOG_DIR = "/opt/apps/kylincloud-remoteappclient/log"
if not os.path.exists(LOG_DIR):
    os.makedirs(LOG_DIR)
LOG_PATH = "%s/record_update.log" % LOG_DIR
if not os.path.exists(LOG_PATH):
    f = open(LOG_PATH, 'w+')
    f.close()
record_log = logging.handlers.RotatingFileHandler(LOG_PATH, maxBytes=1024 * 1024,
                                                  backupCount=5, encoding="utf-8")
fmt = '%(asctime)s - %(funcName)s[line:%(lineno)d] - %(levelname)s - %(message)s'
for_matter = logging.Formatter(fmt)
record_log.setFormatter(for_matter)
logger = logging.getLogger(LOG_PATH)
logger.addHandler(record_log)
logger.setLevel(logging.DEBUG)
path = os.path.join(os.path.expanduser("~"))
UPDATE_DIR = path + "/.clientupdate"


def notify(title=None, message=None, level="INFO"):
    try:
        if title is None:
            return
        if message is None:
            message = title
            log = title
        else:
            log = title + " " + message
        os.system('notify-send [" %s "] "%s"' % (title, message))
        if level == "INFO":
            logger.info(log)
        else:
            logger.warning(log)
    except Exception as e:
        logger.error(e)


def socket_service():
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        s.bind(('127.0.0.1', 13345))
        s.listen(10)
    except socket.error as msg:
        print(msg)
        logger.error(msg)
        sys.exit(1)
    print('Waiting connection...')

    while 1:
        conn, addr = s.accept()
        t = threading.Thread(target=deal_data, args=(conn, addr))
        t.start()


def deal_data(conn, addr):
    while 1:
        data = conn.recv(1024)
        test = format(data.decode())
        try:
            path = test.split(' ')[0]
            logger.info("正在升级")
            print("正在升级")
            cmd = "sudo dpkg -i %s" % path
            p = subprocess.Popen(cmd, close_fds=True, shell=True, env=os.environ)
            p.wait()
            logger.info("升级完成")
            print("升级完成")
            conn.send(b'1')
            time.sleep(1)
        except Exception as e:
            logger.error(str(e))
            print(str(e))
        break


if __name__ == '__main__':
    socket_service()
